//+------------------------------------------------------------------+
//|                                              Fozzy Ea.mq4        |
//|                                              original by igorad  |
//|                                              mod by mrtools      |
//|                                                                  |
//+------------------------------------------------------------------+
//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------

//
//
//
//
//

extern string Expert_Name              = "Fozzy_Ea";
extern bool   EcnBroker                = false;
extern bool   NoHedge                  = false;
extern bool   StrictNoHedge            = false;
extern string SymbolsPrefix            = "";
extern string SymbolsSuffix            = "";
extern bool   UseAutoMagic             = true;
extern int    ManualMagic              = 50000;  
extern int    Slippage                 = 6;

extern string Main_data                = "Trade Volume & Trade Method";
extern double Lots                     = 0.01;
extern double TakeProfit               = 200;     // Take Profit Value 
extern double InitialStop              = 55;      // Initial Stop Value
extern double TrailingStop             = 50;      // Trailing Stop Value 
extern double BreakEven                = 50;      // Break-Even Value
extern double ProfitLock               = 50;      // Break-Even Value
extern bool   SignalMail               = false;

extern string _time                    = "Time Filter";
extern int    StartHour                = 0;       // Start Hour of Trade Session 
extern int    StartMinute              = 0;       // Start Minute of Trade Session 
extern int    EndHour                  = 23;      // End Hour of Trade Session
extern int    EndMinute                = 0;       // End Hour of Trade Session
 
extern string Inputs                   = "BBRSI & MA parameters ";
extern int    TimeFrame                = PERIOD_D1;    
extern double RsiPeriod                = 14;
extern string _rsimethods              = "0=rsi,1=wilder rsi,2=rsx2,3=cuttler rsi ";
extern int    RsiMethod                = 0;
extern int    RsiPrice                 = 0;
extern int    Depth                    = 2;  
extern double Speed                    = 0.5;  
extern int    RsiPriceLinePeriod       = 14;
extern int    RsiPriceLineMAMode       = MODE_LWMA;
extern int    RsiSignalLinePeriod      = 7;
extern int    RsiSignalLineMAMode      = MODE_LWMA;
extern int    VolatilityBandPeriod     = 20;
extern int    VolatilityBandMAMode     = MODE_SMA;
extern double VolatilityBandMultiplier = 2.00;
extern int    bandEntryBar             = 0;

extern string __MaFilter               = "Use MA for entries";
extern bool   UseMaForEntry            = false;
extern int    matf                     = PERIOD_D1;
extern int    FastMaPeriod             = 5;
extern int    FastMaMode               = MODE_SMA;
extern int    FastMaPrice              = PRICE_CLOSE;
extern int    SlowMaPeriod             = 13;
extern int    SlowMaMode               = MODE_SMA;
extern int    SlowMaPrice              = PRICE_CLOSE;
extern int    maEntryBar               = 1;

extern string __MaCrossClose           = "Use MA cross for close";
extern bool   UseMaForClose            = false;
extern int    maClosetf                = PERIOD_D1;
extern int    FastMaClosePeriod        = 20;
extern int    FastMaCloseMode          = MODE_SMA;
extern int    FastMaClosePrice         = PRICE_CLOSE;
extern int    SlowMaClosePeriod        = 50;
extern int    SlowMaCloseMode          = MODE_SMA;
extern int    SlowMaClosePrice         = PRICE_CLOSE;
extern int    maCloseBar               = 1;

extern string MM_inputs                = "MoneyManagement by L.Williams ";
extern bool   MM                       = false;    //  Switch
extern double MMRisk                   = 0.15;     // Risk Factor
extern double MaxLoss                  = 100;      // Maximum Loss by 1 Lot

//
//
//
//
//

int      OrderBar = 0;
int      BEvent = 0, TriesNum = 5;
int      digit = 0;
int      Magic;

double   SellStop,BuyStop,SellProfit,BuyProfit, Lotsi;
double   PointRatio = 1;
double   point;

bool     FirstTime  = false;
string   s_symbol;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int init()
{

                  s_symbol = Symbol();
   if (UseAutoMagic) Magic = GetMagic();
               else  Magic = ManualMagic; 

return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int deinit()  
{ 
 
return(0);  
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int start()
{

  digit  = MarketInfo(s_symbol,MODE_DIGITS);
   if (digit==3 || digit==5) 
         PointRatio = 10;
   else  PointRatio = 1; 
  point  = MarketInfo(s_symbol,MODE_POINT) * PointRatio;
  
  //
  //
  //
  //
  //
    
  if(iBars(s_symbol,TimeFrame) < 100 || IsTradeAllowed()==false) return;    
  if(AccountFreeMargin()< 100*MoneyManagement(MM,Lots,MMRisk,MaxLoss)){Print("We have no money. Free Margin = ", AccountFreeMargin());return(0); }
  
  //
  //
  //
  //
  //
  
  if (UseMaForClose) CheckForClose();
    
  if (ScanTrades() < 1 && (iBars(Symbol(),TimeFrame) != OrderBar || !FirstTime))
  {
    if (TradeSignal() > 0) { BuyOrdOpen() ; FirstTime=true;}
    if (TradeSignal() < 0) { SellOrdOpen(); FirstTime=true;}
  }
  else
  if (ScanTrades() > 0)
  {
     if (TrailingStop > 0 || BreakEven > 0) TrailStop();
  }
  
return(0);
} 

//
// 
//
//
//

int ScanTrades()
{   
   int total = OrdersTotal();
   int numords = 0;
      
   for(int cnt=0; cnt<total; cnt++) 
   {        
   OrderSelect(cnt, SELECT_BY_POS);            
   if(OrderSymbol() == Symbol() && OrderType()<=OP_SELLSTOP && OrderMagicNumber() == Magic) 
   numords++;
   }
   return(numords);
}  

//
//
//
//
//

int TradeSignal()
{   
   
   double RSI     = iCustom(s_symbol,TimeFrame,"rsima_bands",RsiPeriod,"",RsiMethod,RsiPrice,Depth,Speed,RsiPriceLinePeriod,RsiPriceLineMAMode,RsiSignalLinePeriod,RsiSignalLineMAMode,VolatilityBandPeriod,VolatilityBandMAMode,VolatilityBandMultiplier,3,bandEntryBar);
   double MA      = iCustom(s_symbol,TimeFrame,"rsima_bands",RsiPeriod,"",RsiMethod,RsiPrice,Depth,Speed,RsiPriceLinePeriod,RsiPriceLineMAMode,RsiSignalLinePeriod,RsiSignalLineMAMode,VolatilityBandPeriod,VolatilityBandMAMode,VolatilityBandMultiplier,4,bandEntryBar);
   
   double prevRSI = iCustom(s_symbol,TimeFrame,"rsima_bands",RsiPeriod,"",RsiMethod,RsiPrice,Depth,Speed,RsiPriceLinePeriod,RsiPriceLineMAMode,RsiSignalLinePeriod,RsiSignalLineMAMode,VolatilityBandPeriod,VolatilityBandMAMode,VolatilityBandMultiplier,3,bandEntryBar+1);
   double prevMA  = iCustom(s_symbol,TimeFrame,"rsima_bands",RsiPeriod,"",RsiMethod,RsiPrice,Depth,Speed,RsiPriceLinePeriod,RsiPriceLineMAMode,RsiSignalLinePeriod,RsiSignalLineMAMode,VolatilityBandPeriod,VolatilityBandMAMode,VolatilityBandMultiplier,4,bandEntryBar+1);
   
   double UpBB    = iCustom(s_symbol,TimeFrame,"rsima_bands",RsiPeriod,"",RsiMethod,RsiPrice,Depth,Speed,RsiPriceLinePeriod,RsiPriceLineMAMode,RsiSignalLinePeriod,RsiSignalLineMAMode,VolatilityBandPeriod,VolatilityBandMAMode,VolatilityBandMultiplier,0,bandEntryBar);  
   double DnBB    = iCustom(s_symbol,TimeFrame,"rsima_bands",RsiPeriod,"",RsiMethod,RsiPrice,Depth,Speed,RsiPriceLinePeriod,RsiPriceLineMAMode,RsiSignalLinePeriod,RsiSignalLineMAMode,VolatilityBandPeriod,VolatilityBandMAMode,VolatilityBandMultiplier,2,bandEntryBar);  
   double MidBB   = iCustom(s_symbol,TimeFrame,"rsima_bands",RsiPeriod,"",RsiMethod,RsiPrice,Depth,Speed,RsiPriceLinePeriod,RsiPriceLineMAMode,RsiSignalLinePeriod,RsiSignalLineMAMode,VolatilityBandPeriod,VolatilityBandMAMode,VolatilityBandMultiplier,1,bandEntryBar); 
   
   //
   //
   //
   //
   // 
   
   if (UseMaForEntry)
   {
     bool crossUp = (iMA(s_symbol,matf,FastMaPeriod,0,FastMaMode,FastMaPrice,maEntryBar) > iMA(s_symbol,matf,SlowMaPeriod,0,SlowMaMode,SlowMaPrice,maEntryBar));
     bool crossDn = (iMA(s_symbol,matf,FastMaPeriod,0,FastMaMode,FastMaPrice,maEntryBar) < iMA(s_symbol,matf,SlowMaPeriod,0,SlowMaMode,SlowMaPrice,maEntryBar));
   }
   else      
   {
          crossUp = true;
          crossDn = true;
   }  
    
   if (crossUp && RSI > MA && prevRSI < prevMA && RSI > prevRSI && RSI >= MidBB && RSI < UpBB && TimeCondition() && canOpen(OP_BUY))  return( 1);
   if (crossDn && RSI < MA && prevRSI > prevMA && RSI < prevRSI && RSI <= MidBB && RSI > DnBB && TimeCondition() && canOpen(OP_SELL)) return(-1);
}

//
//
//
//
//

double MoneyManagement (bool flag, double Lots, double risk, double maxloss)
{

   Lotsi = Lots;
	    
   if (flag) Lotsi = Lots * NormalizeDouble(Lots * AccountFreeMargin() * risk/maxloss,1);   
     
   if (Lotsi < 0.01) Lotsi = 0.01;  
      
return(Lotsi);
}   

//
//
//
//
//

void TrailStop()
{
   int    error;  
   bool   result=false;
   double Gain = 0;
   
   //
   //
   //
   //
   //
    
   for (int cnt=0;cnt<OrdersTotal();cnt++)
   { 
   OrderSelect(cnt, SELECT_BY_POS);   
   int mode = OrderType();    
      if (OrderSymbol() == s_symbol && OrderMagicNumber() == Magic) 
      {
        if (mode==OP_BUY) 
        {
			 if (BreakEven > 0 && BEvent == 0 )
			 {
			   Gain = (MarketInfo(Symbol(),MODE_BID) - OrderOpenPrice())/point;
			      if( Gain >= BreakEven && OrderStopLoss() <= OrderOpenPrice()+ProfitLock*point) 
			      {
			      double BuyStop = NormalizeDouble(OrderOpenPrice()+ProfitLock*point,digit);
			      BEvent=1;
			      }
			   }
			   
			   //
			   //
			   //
			   //
			   //
			   
			   else 			   
			   if( TrailingStop > 0) BuyStop = NormalizeDouble(MarketInfo(Symbol(),MODE_BID) - TrailingStop*point,digit);
			   
			   //
			   //
			   //
			   //
			   //
			   
			   if(NormalizeDouble(OrderOpenPrice(),digit) <= BuyStop) 
            {   
			      if ( BuyStop > NormalizeDouble(OrderStopLoss(),digit) || OrderStopLoss() == 0) 
			      {
			         for(int k = 0 ; k < TriesNum; k++)
                  {
                  result   =  OrderModify(OrderTicket(),OrderOpenPrice(),BuyStop,OrderTakeProfit(),0,Lime);
                  error    =  GetLastError();
                  if(error == 0) break;
                  else { Sleep(5000); RefreshRates(); continue; }
                  }   		 
               }            
            }
         }  
         
         //
         //
         //
         // 
         // 
                  
         if (mode==OP_SELL)
         {
           if (BreakEven > 0 && BEvent == 0)
			  {
			     Gain = (OrderOpenPrice()-MarketInfo(Symbol(),MODE_ASK))/point;
			   
			     if( Gain >= BreakEven && (OrderStopLoss() >= OrderOpenPrice() - ProfitLock*point || OrderStopLoss()== 0)) 
			     {
			     double SellStop = NormalizeDouble(OrderOpenPrice() - ProfitLock*point,digit);
			     BEvent=-1;
			     }
			   }
			   
			   //
			   //
			   //
			   //
			   //
			   
			   else 
			   if (TrailingStop > 0) SellStop = NormalizeDouble(MarketInfo(Symbol(),MODE_ASK) + TrailingStop*point,digit); 
			   
			   //
			   //
			   //
			   //
			   //
                        
            if (NormalizeDouble(OrderOpenPrice(),digit) >= SellStop && SellStop > 0) 
            {
              if (SellStop < NormalizeDouble(OrderStopLoss(),digit) || OrderStopLoss() == 0) 
              {
                for (k = 0 ; k < TriesNum; k++)
                {
                   result    = OrderModify(OrderTicket(),OrderOpenPrice(),SellStop,OrderTakeProfit(),0,Orange);
                   error     = GetLastError();
                   if(error == 0) break;
                   else { Sleep(5000); RefreshRates(); continue; }
                }
              }   
   		   }	    
         }
      }
   }     
}

// 
//
//
//
//

// ---- Open Sell Orders
//
//
//
//

void SellOrdOpen()
{		     
   double SellPrice = Bid;
   double StopPrice = Bid;
   int    Mode      = OP_SELL;
        	  
   if (InitialStop > 0) SellStop   = StopPrice + InitialStop*point; 
	else                 SellStop   = iHigh(Symbol(),TimeFrame,1);
	
   if (TakeProfit  > 0) SellProfit = SellPrice - TakeProfit*point; 
   else                 SellProfit = 0;
   
   //
   //
   //
   //
   //
   
   if (!EcnBroker)
	OrderSend(s_symbol,Mode,MoneyManagement(MM,Lots,MMRisk,MaxLoss),NormalizeDouble(SellPrice,digit),Slippage*point,
	NormalizeDouble(SellStop,digit),NormalizeDouble(SellProfit,digit),Expert_Name+" SELL",Magic,0,Red);
   
   else
   {
   int sellTicket = OrderSend(s_symbol,Mode,MoneyManagement(MM,Lots,MMRisk,MaxLoss),NormalizeDouble(SellPrice,digit),Slippage*point,0,0,Expert_Name+" SELL",Magic,0,Red);
   if(sellTicket >= 0) 
   {
   bool sellOrderMod = OrderModify(sellTicket,OrderOpenPrice(),NormalizeDouble(SellStop,digit),NormalizeDouble(SellProfit,digit),0,CLR_NONE);
       if (OrderSelect(sellTicket, SELECT_BY_TICKET, MODE_TRADES)) 
       {
		   OrderBar =iBars(OrderSymbol(),TimeFrame);
		   Print("SELL order opened : ", OrderOpenPrice());
         BEvent=0;
         if (SignalMail) SendMail("[Signal Alert]", "[" + s_symbol + "] " + DoubleToStr(Bid,digit) + " Open Sell");
        }
    }
	 else 
	 if(GetLastError() > 0) Print("SELL: OrderSend failed with error #",GetLastError());
    }
return(0);
}

// ---- Open Buy Orders
//
//
//
//

void BuyOrdOpen()
{		     
   double BuyPrice  = Ask;
   double StopPrice = Ask;
   int    Mode      = OP_BUY;
   
   //
   //
   //
   //
   //
     
   if (InitialStop > 0) BuyStop   = StopPrice - InitialStop * point; 
	else                 BuyStop   = iLow(Symbol(),TimeFrame,1);
	
   if (TakeProfit  > 0) BuyProfit = BuyPrice + TakeProfit * point;  
   else                 BuyProfit = 0;  
	
	//
	//
	//
	//
	//
	
	if (!EcnBroker) 
		 
	OrderSend(s_symbol,Mode,MoneyManagement(MM,Lots,MMRisk,MaxLoss),NormalizeDouble(BuyPrice,digit),Slippage*point,
	NormalizeDouble(BuyStop,digit),NormalizeDouble(BuyProfit,digit),Expert_Name+" BUY",Magic,0,Blue);
	
	else
   {
	int buyTicket = OrderSend(s_symbol,Mode,MoneyManagement(MM,Lots,MMRisk,MaxLoss),NormalizeDouble(BuyPrice,digit),Slippage*point,0,0,Expert_Name+" BUY",Magic,0,Blue);
      
   if(buyTicket >= 0) 
   {
   bool buyOrderMod = OrderModify(buyTicket,OrderOpenPrice(),NormalizeDouble(BuyStop,digit),NormalizeDouble(BuyProfit,digit),0,CLR_NONE);
      if (OrderSelect(buyTicket, SELECT_BY_TICKET, MODE_TRADES)) 
      {
		OrderBar =iBars(OrderSymbol(),TimeFrame); 
		Print("BUY order opened : ", OrderOpenPrice());
      BEvent=0;
      if (SignalMail) SendMail("[Signal Alert]", "[" + s_symbol + "] " + DoubleToStr(Ask, Digits) + " Open Buy");
		}
   }
	else 	
   if(GetLastError() > 0) Print("BUY : OrderSend failed with error #",GetLastError());
   }
return(0);
}

//
//
//
//
//

int GetMagic() 
{

   if (s_symbol == SymbolsPrefix+"CADJPY"+SymbolsSuffix) return(500011);
   if (s_symbol == SymbolsPrefix+"CADCHF"+SymbolsSuffix) return(500022);
   
   if (s_symbol == SymbolsPrefix+"GOLD"  +SymbolsSuffix) return(500031);
   if (s_symbol == SymbolsPrefix+"SILVER"+SymbolsSuffix) return(500032);
   
   if (s_symbol == SymbolsPrefix+"NZDJPY"+SymbolsSuffix) return(500041);
   if (s_symbol == SymbolsPrefix+"NZDUSD"+SymbolsSuffix) return(500042);
   
   if (s_symbol == SymbolsPrefix+"CHFJPY"+SymbolsSuffix) return(500051);
   
   if (s_symbol == SymbolsPrefix+"EURAUD"+SymbolsSuffix) return(500061);
   if (s_symbol == SymbolsPrefix+"EURCAD"+SymbolsSuffix) return(500062);
   if (s_symbol == SymbolsPrefix+"EURUSD"+SymbolsSuffix) return(500063);
   if (s_symbol == SymbolsPrefix+"EURGBP"+SymbolsSuffix) return(500064);
   if (s_symbol == SymbolsPrefix+"EURCHF"+SymbolsSuffix) return(500065);
   if (s_symbol == SymbolsPrefix+"EURNZD"+SymbolsSuffix) return(500066);
   if (s_symbol == SymbolsPrefix+"EURJPY"+SymbolsSuffix) return(500067);
   
   if (s_symbol == SymbolsPrefix+"GBPUSD"+SymbolsSuffix) return(500071);
   if (s_symbol == SymbolsPrefix+"GBPCHF"+SymbolsSuffix) return(500072);
   if (s_symbol == SymbolsPrefix+"GBPJPY"+SymbolsSuffix) return(500073);
   
   if (s_symbol == SymbolsPrefix+"USDCHF"+SymbolsSuffix) return(500081);
   if (s_symbol == SymbolsPrefix+"USDJPY"+SymbolsSuffix) return(500082);
   if (s_symbol == SymbolsPrefix+"USDCAD"+SymbolsSuffix) return(500083);

   if (s_symbol == SymbolsPrefix+"AUDUSD"+SymbolsSuffix) return(500091);
   if (s_symbol == SymbolsPrefix+"AUDNZD"+SymbolsSuffix) return(500092);
   if (s_symbol == SymbolsPrefix+"AUDCAD"+SymbolsSuffix) return(500093);
   if (s_symbol == SymbolsPrefix+"AUDCHF"+SymbolsSuffix) return(500094);
   if (s_symbol == SymbolsPrefix+"AUDJPY"+SymbolsSuffix) return(500095);
   
return(ManualMagic);
}

//
//
//
//
//

bool TimeCondition()
{
   bool result = false;
   
   datetime SessionStart = StrToTime(StartHour+":"+StartMinute);
   datetime SessionEnd   = StrToTime(EndHour+":"+EndMinute);
   
   if (StartHour < EndHour)
   result = TimeCurrent() >= SessionStart && TimeCurrent() < SessionEnd; 
        
   else
   
   if (StartHour > EndHour)
   result = (TimeCurrent() >= SessionStart && TimeHour(TimeCurrent()) < 24) || (TimeHour(TimeCurrent()) >= 0 && TimeCurrent() < SessionEnd);
   
return(result);
}  

//
//
//
//
//

bool canOpen(int openWhat)
{
   if (!NoHedge) return(true);

   //
   //
   //
   //
   //
      
      for(int i=0; i < OrdersTotal(); i++)
      {
         if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES) == false) break;
         if (OrderSymbol()                        != s_symbol)   continue;
         if (!StrictNoHedge && OrderMagicNumber() != Magic)      continue;
      
         if (OrderType() == OP_BUY  && openWhat == OP_SELL) return(false); 
         if (OrderType() == OP_SELL && openWhat == OP_BUY)  return(false); 
   }      
return(true);
}

//
//
//
//
//

void CheckForClose()  
{
   RefreshRates();
   double FastMaCloseNow = iMA(s_symbol,maClosetf,FastMaClosePeriod,0,FastMaCloseMode,FastMaClosePrice,maCloseBar);
   double SlowMaCloseNow = iMA(s_symbol,maClosetf,SlowMaClosePeriod,0,SlowMaCloseMode,SlowMaClosePrice,maCloseBar);
   double FastMaClosePre = iMA(s_symbol,maClosetf,FastMaClosePeriod,0,FastMaCloseMode,FastMaClosePrice,maCloseBar+1);
   double SlowMaClosePre = iMA(s_symbol,maClosetf,SlowMaClosePeriod,0,SlowMaCloseMode,SlowMaClosePrice,maCloseBar+1);
   
   //
   //
   //
   //
   //
   
   for (int i = 0;i < OrdersTotal(); i++)
   {
      if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES) == false)  break;
      if (OrderMagicNumber()!= Magic)                         continue;
      if (OrderSymbol()     != s_symbol)                      continue;
      
      //
      //
      //
      //
      //
      
      if (OrderType() == OP_BUY)
      {
        if (FastMaCloseNow < SlowMaCloseNow && FastMaClosePre >= SlowMaClosePre) 
        {
           bool Closed = OrderClose(OrderTicket(),OrderLots(),Bid,Slippage*point,CLR_NONE);
           if (SignalMail) SendMail("[Signal Alert]", "[" + s_symbol + "] " + DoubleToStr(Ask, Digits) + " Buy order closed ");
           
           if (Closed == false)
           {

             string ErrLog = StringConcatenate("Bid: ",Bid," Lots: ",OrderLots(), " Ticket: ",OrderTicket());
             Print(ErrLog);
           }
        }
        break;
      }
      
      //
      //
      //
      //
      //
        
      if (OrderType() == OP_SELL)
      {
        if (FastMaCloseNow > SlowMaCloseNow && FastMaClosePre <= SlowMaClosePre) 
        {
          Closed = OrderClose(OrderTicket(),OrderLots(),Ask,Slippage*point,CLR_NONE);
          if (SignalMail) SendMail("[Signal Alert]", "[" + s_symbol + "] " + DoubleToStr(Ask, Digits) + " Sell order closed"); 
          
          if (Closed == false)
          {

            ErrLog    = StringConcatenate("Ask: ",Ask," Lots: ",OrderLots(), " Ticket: ",OrderTicket());
            Print(ErrLog);
          }
        }
        break;
      }
   }
}  

